%global momorel 12
Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc

%global momonga_release 1.0
%global DATE 20030425
%global gcc_version 3.2.3
%global gcc_release %{momorel}m
%global _unpackaged_files_terminate_build 0

Version: %{gcc_version}
Release: %{gcc_release}
License: GPL
Group: Development/Languages
URL: http://gcc.gnu.org/

############### Defines section

### include local configuration
%{?include_specopt}

### default configurations
#  If you'd like to change these configurations, please copy them to
# /etc/rpm/specopt/gcc.specopt and edit it.

## Configuration
# apply stack-smashing protection patch
%{?!with_ssp:%define with_ssp 1}
# for bootstrap build(remove -fstack-protector from %%{optflags})
%{?!bootstrap_build:%define bootstrap_build 0}

%if !%{with_ssp}
%global bootstrap_build 1
%endif # !with_ssp

Source0: ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}.tar.gz
NoSource: 0
Source1: http://www.research.ibm.com/trl/projects/security/ssp/gcc3_2_2/protector-3.2.2-10.tar.gz
#http://www.research.ibm.com/trl/projects/security/ssp/
NoSource: 1

Patch1: gcc32-sparc32-hack.patch
Patch20: gcc-3.2.2-libjava.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: binutils >= 2.12.90.0.10-2m
BuildPreReq: zlib-devel >= 1.1.4-5m
BuildPreReq: gettext
# Make sure pthread.h doesn't contain __thread tokens
#BuildRequires: glibc-devel >= 2.2.90-12

# for Java AWT
%if !%{bootstrap_build}
BuildPreReq: XFree86-devel
%endif # !bootstrap_build

Requires: cpp = %{version}-%{release}
# Need .eh_frame ld optimizations
# Need proper visibility support
Requires: binutils >= 2.12.90.0.7-1
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
#Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= %{version}-%{release}
Obsoletes: gcc3
Obsoletes: gcc-chill
Obsoletes: egcs
%ifarch sparc sparc64
Obsoletes: egcs64
%endif # sparc && sparc64
Prereq: /sbin/install-info

%global _gnu %{nil}
%{expand: %%{global} _gcc_is_%{_target_cpu} %%{nil}}
%{?_gcc_is_sparc: %global gcc_target_platform sparc64-%{_vendor}-%{_target_os}}
%{!?_gcc_is_sparc: %global gcc_target_platform %{_target_platform}}

%description
The gcc package contains the GNU Compiler Collection version 3.2.
You'll need this package in order to compile C code.
#'

%package -n libgcc
Summary: GCC version 3.2 shared support library
Group: System Environment/Libraries

%description -n libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libstdc++ = %{version}
Requires: libstdc++-devel = %{version}
Obsoletes: gcc3-c++

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++
Summary: GNU Standard C++ Library
Group: System Environment/Libraries
Obsoletes: libstdc++3

%description -n libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package -n libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++ = %{version}-%{release}
Obsoletes: libstdc++3-devel

%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%if !%{bootstrap_build}
%package g77
Summary: Fortran 77 support
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libf2c = %{version}-%{release}
Prereq: /sbin/install-info
Obsoletes: gcc3-g77

%description g77
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU Compiler Collection.

%package -n libf2c
Summary: Fortran 77 runtime
Group: System Environment/Libraries

%description -n libf2c
This package contains Fortran 77 shared library which is needed to run
Fortran 77 dynamically linked programs.

%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libobjc = %{version}-%{release}
Obsoletes: gcc3-objc

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package -n libobjc
Summary: Objective-C runtime
Group: System Environment/Libraries

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgcj >= %{version}, libgcj-devel >= %{version}
Obsoletes: gcc3-java
Prereq: /sbin/install-info

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj
Summary: Java runtime library for gcc
Group: System Environment/Libraries
Requires: java-common, zip >= 2.1
Obsoletes: gcc-libgcj
Obsoletes: libgcj3
# Kaffe includes jar too
#Conflicts: kaffe

%description -n libgcj
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: zip >= 2.1, libgcj = %{version}
Obsoletes: libgcj3-devel

%description -n libgcj-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).
%endif # !bootstrap_build

%ifarch sparc
%package sparc32
Summary: The C compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc = %{version}-%{release}, %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a

%description sparc32
This package contains the GNU C compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package c++-sparc32
Summary: The C++ compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-sparc32 = %{version}-%{release}
Requires: %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so

%description c++-sparc32
This package contains the GNU C++ compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.
%endif # sparc

%package -n cpp
Summary: The C Preprocessor.
Group: Development/Languages
Prereq: /sbin/install-info
%ifarch ia64
Obsoletes: gnupro
%endif # ia64

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%prep
%setup -q

%if %{with_ssp}
pushd gcc/
%{__tar} zxf %{SOURCE1}
%{__patch} -p1 -i ./protector.dif
rm -f ./protector.dif ./protectonly.dif
popd
%endif # with_ssp

%ifarch sparc
%patch1 -p0 -b .sparc32-hack~
%endif # sparc

%if !%{bootstrap_build}
%patch20 -p1 -b .libjava
%endif # !bootstrap_build

# perl -pi -e 's/3\.2\.1/3.2/' gcc/version.c gcc/f/version.c gcc/ada/gnatvsn.ads
perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(\Momonga Linux %{momonga_release} %{version}-%{gcc_release}\)/' gcc/version.c gcc/f/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(%{version}-%{gcc_release}\)/' gcc/ada/gnatvsn.ads
# perl -pi -e 's/#define GCCBUGURL.*$/#define GCCBUGURL "<URL:http:\/\/www.momonga-linux.org\/>"/' gcc/system.h
# The version string is now longer than 32 bytes and the line containing it
# doesn't fit into 80 columns
#perl -pi -e 's/:= 32/:= 64/;s/(Gnat_Version_String.*:=)/\1\n    /' gcc/ada/gnatvsn.ads

./contrib/gcc_update --touch

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  mkdir locale
  localedef -f ISO-8859-1 -i de_DE locale/de_DE
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

CC=gcc
OPT_FLAGS=`echo %{optflags}|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%if %{bootstrap_build}
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-fstack-protector//g'`
%endif # bootstrap_build
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g' -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif # sparc && sparc64
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif # sparc64
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking \
	--with-system-zlib --enable-__cxa_atexit \
%if %{bootstrap_build}
	--enable-languages='c,c++' \
	--disable-libgcj --disable-libjava --disable-libobjc \
%else # !bootstrap_build
	--enable-languages='c,c++,f77,java,objc' \
	--enable-java-gc=boehm --enable-java-awt=xlib \
%endif # !bootstrap_build
%ifarch sparc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%else # !sparc
	--host=%{gcc_target_platform}
%endif # !sparc


%if !%{with_ssp}
# if RPM_BUILD_NCPUS unset, set it
if [ -z "$RPM_BUILD_NCPUS" ] ; then
  if [ -x /usr/bin/getconf ] ; then
    RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $RPM_BUILD_NCPUS -eq 0 ]; then
      RPM_BUILD_NCPUS=1
    fi
  else
    RPM_BUILD_NCPUS=1
  fi
fi
%else # !with_ssp
RPM_BUILD_NCPUS=1
%endif # !with_ssp
make -j$RPM_BUILD_NCPUS bootstrap-lean
#make -j$RPM_BUILD_NCPUS bootstrap

# run the tests.
make -j$RPM_BUILD_NCPUS -k check || :
%ifarch %{ix86}
CANONP=i686-pc-linux-gnu
%endif # ix86
%ifarch alpha
CANONP=alphaev67-unknown-linux-gnu
%endif # alpha
%ifarch ia64
CANONP=ia64-unknown-linux-gnu
%endif # ia64
if [ -n "$CANONP" ]; then
  ln -sf $CANONP ../libstdc++-v3/config/abi/%{gcc_target_platform}
  ln -sf $CANONP ../libstdc++-v3/config/abi/%{gcc_target_platform}-gnu
fi
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
if [ -d ../libstdc++-v3/config/abi/%{gcc_target_platform}-gnu ]; then
  make -C %{gcc_target_platform}/libstdc++-v3 check-abi
fi
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

%if %{bootstrap_build}
OPT_FLAGS=`echo "%{optflags}"|sed -e 's/-fstack-protector//g'`
%endif # bootstrap_build

%ifarch sparc
# Build the -m32 only compiler which does not use long long for HOST_WIDE_INT
mkdir gcc32
cd gcc32
OPT_FLAGS=`echo "$OPT_FLAGS"|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
echo "#!/bin/sh" > gcc32
echo "exec `cd ../gcc; pwd`/xgcc -B `cd ../gcc; pwd`/ $OPT_FLAGS \$*" >> gcc32
chmod +x gcc32
CC=`pwd`/gcc32 CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" \
  TCFLAGS="$OPT_FLAGS" ../../gcc/configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
  --enable-shared --enable-threads=posix --disable-checking \
  --with-system-zlib --enable-__cxa_atexit \
  --host=%{_target_platform}
make cc1 cc1plus
cd ..
%endif # sparc

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
%if !%{bootstrap_build}
mkdir -p rpm.doc/g77
mkdir -p rpm.doc/objc
mkdir -p rpm.doc/boehm-gc
mkdir -p rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava
%endif # !bootstrap_build

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
%if !%{bootstrap_build}
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)
%endif # !bootstrap_build

%install
rm -fr %{buildroot}

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{gcc_target_platform}/libstdc++-v3
%if !%{bootstrap_build}
make -C %{gcc_target_platform}/libjava
%endif # !bootstrap_build

make prefix=%{buildroot}%{_prefix} mandir=%{buildroot}%{_mandir} \
  infodir=%{buildroot}%{_infodir} install

FULLPATH=%{buildroot}%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}

file %{buildroot}/%{_prefix}/bin/* | grep ELF | cut -d':' -f1 | xargs strip || :
strip $FULLPATH/{cc1,cc1plus,cpp0,tradcpp0}
%if !%{bootstrap_build}
strip $FULLPATH/{f771,cc1obj,jc1,jvgenmain}
%endif # !bootstrap_build

# fix some things
ln -sf gcc %{buildroot}%{_prefix}/bin/cc
mkdir -p %{buildroot}/lib
ln -sf ..%{_prefix}/bin/cpp %{buildroot}/lib/cpp
%if !%{bootstrap_build}
ln -sf g77 %{buildroot}%{_prefix}/bin/f77
%endif # !bootstrap_build
rm -f %{buildroot}%{_infodir}/dir
gzip -9 %{buildroot}%{_infodir}/*.info*
#ln -sf gcc %{buildroot}%{_prefix}/bin/gnatgcc


%if !%{bootstrap_build}
for prog in jar rmic rmiregistry; do
%__mv -f %{buildroot}%{_bindir}/$prog %{buildroot}%{_bindir}/gcj-$prog
done
for prog in rmic rmiregistry; do
%__mv -f %{buildroot}%{_mandir}/man1/$prog.1 %{buildroot}%{_mandir}/man1/gcj-$prog.1
done
%endif # !bootstrap_build

%ifarch sparc
# Install the sparc -m32 only compilers
FULLPATH32=%{buildroot}%{_libdir}/gcc-lib/%{_target_platform}/%{gcc_version}
mkdir -p $FULLPATH32
install -m 755 gcc32/cc1 $FULLPATH32/
install -m 755 gcc32/cc1plus $FULLPATH32/
ln -sf ../../%{gcc_target_platform}/%{gcc_version}/include $FULLPATH32/
strip $FULLPATH32/{cc1,cc1plus}
ln -f %{buildroot}%{_prefix}/bin/%{gcc_target_platform}-gcc \
  %{buildroot}%{_prefix}/bin/%{_target_platform}-gcc
%endif # sparc
%ifarch sparc64
ln -f %{buildroot}%{_prefix}/bin/%{gcc_target_platform}-gcc \
  %{buildroot}%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif # sparc64

%ifarch sparc
FULLLPATH=$FULLPATH/lib32
%endif # sparc
%ifarch sparc64
FULLLPATH=$FULLPATH/lib64
%endif # sparc64
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

%if !%{bootstrap_build}
mv %{buildroot}%{_libdir}/libgcj.*a $FULLLPATH/
mv %{buildroot}%{_libdir}/libgcjx.*a $FULLLPATH/
sed 's/-lgcjgc//g;s/-lzgcj//g;s/-lpthread//g' %{buildroot}%{_libdir}/libgcj.spec > $FULLPATH/libgcj.spec
mv %{buildroot}%{_prefix}/include/gc*.h $FULLPATH/include/
mv %{buildroot}%{_prefix}/include/j*.h $FULLPATH/include/
mv -f %{buildroot}%{_prefix}/include/{java,javax,gnu,org} $FULLPATH/include/
mkdir -p $FULLPATH/include/gcj
mv -f %{buildroot}%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
rmdir %{buildroot}%{_prefix}/include/gcj

%ifarch sparc64 x86_64 s390x
pushd %{buildroot}%{_libdir}
mv -f libobjc.so* ../%{_lib}/
mv -f libstdc++.so* ../%{_lib}/
mv -f libgcj.so* ../%{_lib}/
mv -f libgcjx.so* ../%{_lib}/
mv -f libg2c.so* ../%{_lib}/
popd
%endif # sparc64 && x86_64 && s390x
%endif # !bootstrap_build

mkdir -p %{buildroot}/%{_lib}
mv -f %{buildroot}%{_libdir}/libgcc_s.so.1 %{buildroot}/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 %{buildroot}/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 %{buildroot}/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so

%ifarch sparc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/libgcc_s_64.so
%endif # sparc
%ifarch sparc64 x86_64 s390x
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
%endif # sparc64 && x86_64 && s390x

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libstdc++.so.5.* libstdc++.so
%if !%{bootstrap_build}
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libgcj.so.3.* libgcj.so
ln -sf ../../../libgcjx.so.3.* libgcjx.so
ln -sf ../../../libg2c.so.0.* libg2c.so
%endif # !bootstrap_build
else
ln -sf ../../../../%{_lib}/libstdc++.so.5.* libstdc++.so
%if !%{bootstrap_build}
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libgcj.so.3.* libgcj.so
ln -sf ../../../../%{_lib}/libgcjx.so.3.* libgcjx.so
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
%endif # !bootstrap_build
fi
mv -f %{buildroot}%{_libdir}/libstdc++.*a $FULLLPATH/
mv -f %{buildroot}%{_libdir}/libsupc++.*a .
%if !%{bootstrap_build}
mv -f %{buildroot}%{_libdir}/libfrtbegin.*a .
mv -f %{buildroot}%{_libdir}/libg2c.*a .
mv -f %{buildroot}%{_libdir}/libobjc.*a .
%endif # !bootstrap_build

%ifarch sparc
ln -sf ../`echo ../../../../lib/libstdc++.so.5.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
mv -f $RPM_BUILD_ROOT%{_libdir}/64/libsupc++.*a 64/
ln -sf lib32/libstdc++.a libstdc++.a
ln -sf ../lib64/libstdc++.a 64/libstdc++.a
%endif # sparc
%ifarch sparc64 x86_64 s390x
ln -sf ../`echo ../../../../lib64/libstdc++.so.5.* | sed s~/../lib64/~/~` 32/libstdc++.so
mv -f $RPM_BUILD_ROOT%{_libdir}/32/libsupc++.*a 32/
%endif # sparc64 || x86_64 || s390x
%ifarch sparc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
%endif # sparc64
%ifarch x86_64
ln -sf ../../../i386-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
%endif # x86_64
%ifarch s390x
ln -sf ../../../s390-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
%endif # s390x

%if !%{bootstrap_build}
%ifarch sparc
ln -sf ../../../../../lib64/libobjc.so.1 64/libobjc.so
ln -sf ../`echo ../../../../lib/libgcj.so.3.* | sed s~/lib/~/lib64/~` 64/libgcj.so
ln -sf ../`echo ../../../../lib/libgcjx.so.3.* | sed s~/lib/~/lib64/~` 64/libgcjx.so
ln -sf ../`echo ../../../../lib/libg2c.so.0.* | sed s~/lib/~/lib64/~` 64/libg2c.so
mv -f $RPM_BUILD_ROOT%{_libdir}/64/libfrtbegin.*a 64/
mv -f $RPM_BUILD_ROOT%{_libdir}/64/libg2c.*a 64/
mv -f $RPM_BUILD_ROOT%{_libdir}/64/libobjc.*a 64/
ln -sf lib32/libgcj.a libgcj.a
ln -sf ../lib64/libgcj.a 64/libgcj.a
ln -sf lib32/libgcjx.a libgcjx.a
ln -sf ../lib64/libgcjx.a 64/libgcjx.a
%endif # sparc
%ifarch sparc64 x86_64 s390x
ln -sf ../../../../libobjc.so.1 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libgcj.so.3.* | sed s~/../lib64/~/~` 32/libgcj.so
ln -sf ../`echo ../../../../lib64/libgcjx.so.3.* | sed s~/../lib64/~/~` 32/libgcjx.so
ln -sf ../`echo ../../../../lib64/libg2c.so.0.* | sed s~/../lib64/~/~` 32/libg2c.so
mv -f $RPM_BUILD_ROOT%{_libdir}/32/libfrtbegin.*a 32/
mv -f $RPM_BUILD_ROOT%{_libdir}/32/libg2c.*a 32/
mv -f $RPM_BUILD_ROOT%{_libdir}/32/libobjc.*a 32/
%endif # sparc64 || x86_64 || s390x
%ifarch sparc64
ln -sf ../lib32/libgcj.a 32/libgcj.a
ln -sf lib64/libgcj.a libgcj.a
ln -sf ../lib32/libgcjx.a 32/libgcjx.a
ln -sf lib64/libgcjx.a libgcjx.a
%endif # sparc64
%ifarch x86_64
ln -sf ../../../i386-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj.a 32/libgcj.a
ln -sf ../../../i386-%{_vendor}-%{_target_os}/%{gcc_version}/libgcjx.a 32/libgcjx.a
%endif # x86_64
%ifarch s390x
ln -sf ../../../s390-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj.a 32/libgcj.a
ln -sf ../../../s390-%{_vendor}-%{_target_os}/%{gcc_version}/libgcjx.a 32/libgcjx.a
%endif # s390x

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libg2c.a -o -name libobjc.a -o -name libgcj.a -o -name libgcjx.a -o -name libgcc.a \) -a -type f`

chmod 755 %{buildroot}%{_libdir}/libg2c.so.0.*
chmod 755 %{buildroot}%{_libdir}/libobjc.so.1.*

%endif # !bootstrap_build
popd

cat > %{buildroot}%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
           exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF

cat > %{buildroot}%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
           exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF

chmod 755 %{buildroot}%{_prefix}/bin/c?9

cd ..
%find_lang %{name}

%ifarch %{ix86}
pushd %{buildroot}%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}
mv specs specs~
## fix specs for ssp
sed -e 's/^%%{static|static-libgcc:-lgcc -lgcc_eh}/%%{static|static-libgcc:-lgcc -lgcc_eh %%{profile:-lc_p} %%{!profile: -lc}}/' < specs~ > specs
popd
%endif

%clean
rm -rf %{buildroot}

%post
if [ -f %{_infodir}/gcc.info.bz2 ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcc.info.bz2
elif [ -f %{_infodir}/gcc.info.gz ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
else
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcc.info
fi

%preun
if [ $1 = 0 ]; then
  if [ -f %{_infodir}/gcc.info.bz2 ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcc.info.bz2
  elif [ -f %{_infodir}/gcc.info.gz ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
  else
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcc.info
  fi
fi

%post -n cpp
if [ -f %{_infodir}/cpp.info.bz2 ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/cpp.info.bz2
elif [ -f %{_infodir}/cpp.info.gz ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
else
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/cpp.info
fi

%preun -n cpp
if [ $1 = 0 ]; then
  if [ -f %{_infodir}/cpp.info.bz2 ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/cpp.info.bz2
  elif [ -f %{_infodir}/cpp.info.gz ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
  else
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/cpp.info
  fi
fi

%post -n libgcc -p /sbin/ldconfig

%postun -n libgcc -p /sbin/ldconfig

%post -n libstdc++ -p /sbin/ldconfig

%postun -n libstdc++ -p /sbin/ldconfig

%if !%{bootstrap_build}
%post g77
if [ -f %{_infodir}/g77.info.bz2 ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/g77.info.bz2
elif [ -f %{_infodir}/g77.info.gz ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/g77.info.gz
else
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/g77.info
fi

%preun g77
if [ $1 = 0 ]; then
  if [ -f %{_infodir}/g77.info.bz2 ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/g77.info.bz2
  elif [ -f %{_infodir}/g77.info.gz ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/g77.info.gz
  else
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/g77.info
  fi
fi

%post java
if [ -f %{_infodir}/gcj.info.bz2 ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcj.info.bz2
elif [ -f %{_infodir}/gcj.info.gz ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
else
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/gcj.info
fi

%preun java
if [ $1 = 0 ]; then
  if [ -f %{_infodir}/gcj.info.bz2 ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcj.info.bz2
  elif [ -f %{_infodir}/gcj.info.gz ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
  else
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gcj.info
  fi
fi

%post -n libobjc -p /sbin/ldconfig

%postun -n libobjc -p /sbin/ldconfig

%post -n libgcj
/sbin/ldconfig
if [ -f %{_infodir}/fastjar.info.bz2 ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/fastjar.info.bz2
elif [ -f %{_infodir}/fastjar.info.gz ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
elif [ -f %{_infodir}/fastjar.info ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/fastjar.info
fi

%{_sbindir}/alternatives --install %{_bindir}/jar jar %{_bindir}/gcj-jar 40
%{_sbindir}/alternatives --install %{_bindir}/rmic rmic %{_bindir}/gcj-rmic 40 \
	--slave %{_mandir}/man1/rmic.1.bz2 rmic.1.bz2 %{_mandir}/man1/gcj-rmic.1.bz2
%{_sbindir}/alternatives --install %{_bindir}/rmiregistry rmiregistry %{_bindir}/gcj-rmiregistry 40 \
	--slave %{_mandir}/man1/rmiregistry.1.bz2 rmiregistry.1.bz2 %{_mandir}/man1/gcj-rmiregistry.1.bz2

%preun -n libgcj
if [ $1 = 0 ]; then
  if [ -f %{_infodir}/fastjar.info.bz2 ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/fastjar.info.bz2
  elif [ -f %{_infodir}/fastjar.info.gz ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
  elif [ -f %{_infodir}/fastjar.info ]; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/fastjar.info
  fi
fi

%postun -n libgcj
/sbin/ldconfig
%{_sbindir}/alternatives --remove jar %{_bindir}/gcj-jar
%{_sbindir}/alternatives --remove rmic %{_bindir}/gcj-rmic
%{_sbindir}/alternatives --remove rmiregistry %{_bindir}/gcj-rmiregistry

%post -n libf2c -p /sbin/ldconfig

%postun -n libf2c -p /sbin/ldconfig
%endif # !bootstrap_build

%files -f %{name}.lang
%defattr(-,root,root)
%{_bindir}/cc
%{_bindir}/c89
%{_bindir}/c99
%{_bindir}/gcc
%{_bindir}/gcov
%{_bindir}/protoize
%{_bindir}/unprotoize
%ifarch sparc
%{_bindir}/%{_target_platform}-gcc
%endif # sparc
%ifarch sparc64
%{_bindir}/sparc-%{_vendor}-%{_target_os}-gcc
%endif # sparc64
%{_bindir}/%{gcc_target_platform}-gcc
%{_mandir}/man1/gcc.1*
%{_mandir}/man1/gcov.1*
%{_infodir}/gcc*
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%ifarch %{ix86} x86_64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%endif # ix86 && x86_64
%ifarch ia64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif # ia64
%ifarch ppc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%endif # ppc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/README
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/collect2
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%ifarch sparc
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s_64.so
%endif # sparc
%ifarch sparc64 x86_64 s390x
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%endif # sparc64 && x86_64 && s390x
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/specs
%doc gcc/README* gcc/*ChangeLog*

%files -n cpp
%defattr(-,root,root)
/lib/cpp
%{_bindir}/cpp
%{_mandir}/man1/cpp.1*
%{_infodir}/cpp*
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cpp0
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/tradcpp0

%files -n libgcc
%defattr(-,root,root)
/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
/%{_lib}/libgcc_s.so.1

%files c++
%defattr(-,root,root)
%{_bindir}/%{gcc_target_platform}-*++
%{_bindir}/g++
%{_bindir}/c++
%{_bindir}/c++filt
%{_mandir}/man1/g++.1*
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif # sparc
%ifarch sparc64 x86_64 s390x
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif # sparc64 && x86_64 && s390x
%ifarch sparc sparc64 x86_64 s390x
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif # sparc && sparc64 && x86_64 && s390x
%ifarch sparc sparc64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif # sparc && sparc64
%doc gcc/cp/ChangeLog*

%files -n libstdc++
%defattr(-,root,root)
%{_libdir}/libstdc++.so.5*

%files -n libstdc++-devel
%defattr(-,root,root)
%{_includedir}/c++
%ifarch sparc
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%endif # sparc
%ifarch sparc64
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif # sparc64
%ifnarch sparc sparc64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif # sparc && sparc64
%ifnarch sparc sparc64 x86_64 s390x
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif # sparc && sparc64 && x86_64 && s390x
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

%if !%{bootstrap_build}
%files g77
%defattr(-,root,root)
%{_bindir}/g77
%{_bindir}/f77
%{_mandir}/man1/g77.1*
%{_infodir}/g77*
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/f771
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libfrtbegin.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libg2c.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libg2c.so
%ifarch sparc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libfrtbegin.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libg2c.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libg2c.so
%endif
%ifarch sparc64 x86_64 s390x
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libfrtbegin.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libg2c.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libg2c.so
%endif
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/g2c.h
%doc gcc/f/README rpm.doc/g77/*

%files -n libf2c
%defattr(-,root,root)
%{_libdir}/libg2c.so.0*

%files objc
%defattr(-,root,root)
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/objc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1obj
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libobjc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libobjc.so
%ifarch sparc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libobjc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libobjc.so
%endif # sparc
%ifarch sparc64 x86_64 s390x
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libobjc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libobjc.so
%endif # sparc64 && x86_64 && s390x
%doc rpm.doc/objc/*
%doc libobjc/THREADS* libobjc/ChangeLog

%files -n libobjc
%defattr(-,root,root)
%{_libdir}/libobjc.so.1*

%files java
%defattr(-,root,root)
%{_bindir}/gcj
%{_bindir}/gcjh
%{_bindir}/jcf-dump
%{_bindir}/jv-scan
%{_mandir}/man1/gcj.1*
%{_mandir}/man1/gcjh.1*
%{_mandir}/man1/jcf-dump.1*
%{_mandir}/man1/jv-scan.1*
%{_infodir}/gcj*
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/jc1
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcjx.so
%ifarch sparc sparc64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcjx.a
%endif # sparc && sparc64
%ifarch sparc
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcj.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcjx.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcjx.a
%endif # sparc
%ifarch sparc64 x86_64 s390x
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcjx.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcjx.a
%endif # sparc64 && x86_64 && s390x
%doc gcc/java/ChangeLog*

%files -n libgcj
%defattr(-,root,root)
%{_bindir}/jv-convert
%{_bindir}/gij
%{_bindir}/gcj-jar
%{_bindir}/grepjar
%{_bindir}/gcj-rmic
%{_bindir}/gcj-rmiregistry
# %{_mandir}/man1/jar.1*
# %{_mandir}/man1/grepjar.1*
%{_mandir}/man1/jv-convert.1*
%{_mandir}/man1/gij.1*
%{_mandir}/man1/gcj-rmic.1*
%{_mandir}/man1/gcj-rmiregistry.1*
# %{_infodir}/fastjar*
%{_libdir}/libgcj.so.*
%{_libdir}/libgcjx.so.*
%{_datadir}/java/libgcj-%{version}.jar
%{_libdir}/security

%files -n libgcj-devel
%defattr(-,root,root)
%{_bindir}/addr2name.awk
%ifarch sparc
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/libgcjx.a
%endif # sparc
%ifarch sparc64
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/libgcjx.a
%endif # sparc64
%ifnarch sparc sparc64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcjx.a
%endif # sparc && sparc64
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gc*.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/j*.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/java
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/javax
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gnu
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gcj
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/org
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*
%endif # !bootstrap_build

%ifarch sparc
%files sparc32
%defattr(-,root,root)
%dir %{_libdir}/gcc-lib/%{_target_platform}/%{gcc_version}
%{_libdir}/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{_libdir}/gcc-lib/%{_target_platform}/%{gcc_version}/include

%files c++-sparc32
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%endif

%changelog
* Fri Jan 09 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-12m)
- fix alternatives about libgcj

* Thu Jan  8 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.2.3-11m)
- change momonga_release to 1.0

* Sun Nov 23 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-10m)
- s/Copyright:/License:/

* Fri Oct 10 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (3.2.3-9m)
- alternatives(jar, rmic, rmiregistry and their manpages)

* Mon Oct  6 2003 Hideo TASHIRO <tashiron@jasmiso.org>
- (3.2.3-8m)
- fix typo   s/bootstarp/bootstrap/g
- it is made not to make gcj-jar when bootstrap_build

* Thu Aug  7 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.3-7m)
- update ssp patch to 3.2.2-10

* Thu Jul 24 2003 HOSONO Hidetomo <h12o@h12o.org>
- (3.2.3-6m)
- remove gcc-specs-sspfix.diff
- add a sed one-liner instead of patching gcc-specs-sspfix.diff

* Sat Jul 19 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.3-5m)
- rebuild against glibc-2.3.2

* Sun Jul  6 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.3-4m)
- rebuild against rpm.

* Sat Jun 28 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.3-3m)
- mv jar gcj-jar for kaffe.

* Thu May 08 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-2m)
- update ssp protector patch to 3.2.2-7

* Sat Apr 26 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.3-1m)
- update to 3.2.3
- fix rpm macros miss in files section at ifarch sparc (s|{_libdir}|%%{_libdir}|g)
- change "%%{__tar} zxvf" to "%%{__tar} zxf" %%{SOURCE1} (ssp patch)
- update DATE macro, unneed?

* Sun Apr 20 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-15m)
- cancel patch0 because can not build kernel.

* Sun Apr 20 2003 HOSONO Hidetomo <h12o@h12o.org>
- (3.2.2-14m)
- fix the URL of Source1:

* Fri Apr 18 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-13m)
- synchronize to RH9.

* Tue Apr 15 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-12m)
- syncronize to rawhide gcc (3.2.2-10).

* Sun Apr 13 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-11m)
- modify argument of install-info.

* Fri Apr 04 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.2-10m)
- rebuild against zlib 1.1.4-5m
- add BuildPrereq: zlib-devel >= 1.1.4-5m

* Sun Mar 23 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.2-9m)
- move Name: section top of spec file [Momonga-devel.ja:01504] 
- comment out <URL:http:\/\/www.momonga-linux.org\/> gcc/system.h
  using URL when cc1 internal compile error...
- change %%{_prefix}/%%{_lib} to %%{_libdir}

* Sun Mar 16 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-8m)
- update ssp patch to 3.2.2-3 
- fix specs for ssp(gcc-specs-sspfix.diff)

* Fri Feb 28 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-7m)
- update ssp patch

* Tue Feb 18 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-6m)
- install hoge.info instead of hoge.info.* in %%post and %%preun
- fix error of %%post on libgcj

* Mon Feb 17 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-5m)
- libgcj must contain libgcjx.

* Mon Feb 17 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-4m)
- modify the %%install section to fix to unmatch pushd/popd pair in
  positive bootstrap_build.
- use --enable-languages option in configure.

* Mon Feb 17 2003 Kenta MURATA <muraken2@nifty.com>
- (3.2.2-3m)
- enable java-awt support.
- disable compile g77, objc and java support when bootstrap_build is
  positive.

* Tue Feb 11 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2.2-2m)
- fix ssp

* Sat Feb  8 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (3.2.2-1m)
  update to 3.2.2

* Mon Jan 20 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-9m)
- fix %%post and %%preun of libgcj for compressed info file

* Wed Nov 27 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-8m)
- sync with redhat(gcc-3.2-14)
- add changelog of redhat gcc-3.2-14(rawhide) below
-
-* Sun Nov 17 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-14
-- really fix check-abi problem on ia64/alpha
-
-* Sat Nov 16 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-13
-- update from gcc-3_2-rhl8-branch
-  - fix flow (Graham Scott, Jan Hubicka)
-  - fix check-abi problem on ia64/alpha (Benjamin Kosnik)
-  - fix objc on x86_64 (Jan Hubicka, Nicola Pero)
-  - fix x86_64 profiling (Jan Hubicka)
-  - better s390* .eh_frame encoding (Ulrich Weigand)
-- build ada on x86_64
-- add fastjar info and jar and grepjar manual pages
-
-* Tue Nov 12 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-12
-- update from gcc-3_2-rhl8-branch
-  - PRs c/8467, preprocessor/4890, 8502, c/5351, optimization/7591,
-    bootstrap/8146, c/8252, optimization/7520, c/8451, c++/8391,
-    target/7856, target/7133, target/6890, middle-end/6994, opt/7944,
-    c/761, c++/7788, c++/2521, c++/8160, c++/8149, c++/8287,
-    middle-end/6994, c++/7266, c++/7228, c++/8067, c++/7679,
-    c++/6579, java/7830, libstdc++/8362, libstdc++/8258, libstdc++/7219,
-    libstdc++/8466, libstdc++/8172, libstdc++/8197, libstdc++/8318,
-    libstdc++/8348, libstdc++/7961, other/3337, bootstrap/6763,
-    bootstrap/8122, libstdc++/8347
-  - &&lab1 - &&lab2 doesn't need to be in rw section
-  - x86_64 %rip fixes
-  - fix jar c without f (#77062)
-  - backport all fastjar changes from mainline
-
-* Wed Oct 23 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-11
-- update from gcc-3_2-rhl8-branch
-  - PRs target/7693, opt/7630, c++/6419, target/7396, c++/8218,
-    c++/7676, c++/7584, c++/7478, c++/8134, c++/7524, c++/7176,
-    c++/5661, c++/6803, c++/7721, c++/7803, c++/7754, c++/7188,
-    libstdc++/8071, libstdc++/8127, c++/6745, libstdc++/8096,
-    libstdc++/7811
-- fix x86-64 ICE with stdarg in -fpic (#76491)
-- fix IA-32 miscompilation of DImode code (Jim Wilson, PR target/6981)
-
-* Wed Oct 16 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-10
-- update from gcc-3_2-rhl8-branch
-  - PRs target/7370, target/8232, opt/7409, preprocessor/7862,
-    preprocessor/8190, optimization/6631, target/5610, optimization/7951,
-    target/7723
-- allow building even if de_DE locale is not installed (#74503, #75889)
-- s390x multilib
-- x86-64 TLS fixes
-- 15 Java fixes (Anthony Green, Andrew Haley, Tom Tromey,
-  PRs java/6005, java/7611, java/8003, java/7950, java/5794, libgcj/7073)
-- %%define _unpackaged_files_terminate_build 0
-- fix make check-abi
-
-* Fri Oct 11 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-9
-- update from gcc-3_2-rhl8-branch
-  - __attribute__((tls_model("")))
-  - PRs c/7353, opt/7124, opt/7912, opt/7390, doc/7484,
-        c/7411, target/8087, optimization/6713
-- x86-64 TLS
-
-* Tue Oct  8 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-8
-- switch to gcc-3_2-rhl8-branch snapshots
-  - thus most of the patches went away as they are in CVS
-- merge from gcc-3_2-branch between 20020903 and 20021007
-  - PRs target/7434, optimization/6627, preprocessor/8120,
-       middle-end/7151, preprocessor/8055, optimization/7335,
-       c/7160, target/7842, opt/7515, optimization/7130,
-       optimization/6984, c/7150, target/7380, other/7114,
-       target/5967, optimization/7120, target/7374, opt/7814,
-       c/7102
-- backported libffi and libjava bits for x86-64 and s390*
-- added sparc* support
-- multilib setup for sparc* and x86-64
-- some IA-32 TLS fixes (Richard Henderson)

* Thu Nov 27 2002 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2-7m)
- update protector patch protector-3.2-3 to protector-3.2-5
- add BuildPreReq: binutils >= 2.13.90.0.10-2m

* Sat Nov  9 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-6m)
- add Obsoletes: gcc-chill

* Sun Nov  3 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-5m)
- add bootstrap_build macro(to remove -fstack-protector from %%optflags)

* Thu Oct 24 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-4m)
- enable ssp by default

* Wed Oct  9 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-3m)
- %%{?include_specopt}
- add ssp patch, See <http://www.trl.ibm.com/projects/security/ssp/>
  disabled by default

* Sun Oct  6 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-2m)
- delete ada

* Tue Oct  1 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.2-1m)
- update to 3.2
  sync with gcc-3.2 of redhat 8.0(gcc-3.2-7.src.rpm)

* Thu Aug  1 2002 Tsutomu Yasuda <tom@tom.homelinux.org>
- (3.1.1-1m)
  update to 3.1.1

* Tue Jul 17 2002 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.96-9m)
- s/Kondara MNU 2.1 Linux/Momonga Linux/
- change Source0 URI

* Wed May 29 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.1-8k)
  applied patch
  see http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=view%20audit-trail&database=gcc&pr=6703

* Sat May 25 2002 Toru Hoshina <t@kondara.org>
- (3.1-6k)
- remove disgusting make check.
- apply athlon optimize patch,
  See http://gcc.gnu.org/ml/gcc/2002-05/msg01743.html

* Fri May 24 2002 Toru Hoshina <t@kondara.org>
- (3.1-4k)
- revised spec.

* Thu May 23 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.1-2k)
  merge from rawhide
  3.1 first release
